# Uma matrix é um Quadrado Mágico se a soma de todas as linhas, colunas e diagonais é
# igual 

using Test

function verifica()
  println("Início dos testes")
  @test quadradoMagico([10])
  @test !quadradoMagico([1 2; 2 1])
  @test quadradoMagico([2 7 6; 9 5 1; 4 3 8])
  @test quadradoMagico([16 3 2 13; 5 10 11 8; 9 6 7 12; 4 15 14 1])
  @test !quadradoMagico([1 2 3; 2 3 1; 3 1 2])
  println("Final dos testes")
end

function quadradoMagico(m)
  if length(m) == 1
    return true
  end
  a = size(m)
  if length(a) != 2 || a[1] != a[2]
    return false
  end

  somaP = 0
  for i in 1:a[1]
    somaP = somaP + m[i, i]
  end

  soma = 0
  for i in 1:a[1]
    somaL = 0
    somaC = 0
    soma = soma + m[i, a[1] - i + 1]
    for j in 1:a[1]
       somaL = somaL + m[i, j]
       somaC = somaC + m[j ,i]
    end
    if somaL != somaP || somaC != somaP
       return false
    end
  end
  if soma != somaP
    return false
  end
  return true
end

verifica()
